#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#define ll long long
using namespace std;


void bfs(int &start, int &maximH, vector<set<int>> &g, vector<bool> &visited) {
    deque<pair<int, int>> q;
    q.push_back({start, 0});
    visited[start] = true;
    while (!q.empty()) {
        int node = q.front().first;
        int dist = q.front().second;
        q.pop_front();
        if (dist< maximH) {
            for (auto n: g[node]) {
                if (visited[n] == false) {
                    visited[n]=true;
                    q.push_back({n, dist+1});
                }
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, k; cin >> n >> m >> k;
    vector<set<int>> g(n);
    for (int i=0;i<m;++i) {
        int a, b; cin >> a >> b;
        a--;b--;
        g[a].insert(b);
        g[b].insert(a);
    }
    vector<bool> vis(n, false);
    for (int i=0;i<k;++i) {
        int p, h; cin >> p >> h;
        --p;
        bfs(p, h, g, vis);
    }
    vector<int> answer;
    for (int i=0;i<n;++i) {
        if (vis[i]) {
            answer.push_back(i+1);
        }
    }
    cout << answer.size() << '\n';
    for (auto i: answer) cout << i << ' ';
}

